#include<reg51.h>
char count;					//Count the variable to decide 10 times or 5 times of 50msec delay.
sbit mybit=P1^5;				//Define mybit as P1.5 pin.
sbit sw=P1^2;				//Define sw as P1.2 pin.
void delay (void) interrupt 1			//ISR for timer 0.
{
   if(count==0)				//If 5 or 10 times 50msec delays are over toggle P1.5 pin 
  {							//and reinitialize the count
   	  mybit=~mybit;			//according to the switch position.
	  if(sw)
	  count=5;
	  else
	  count=10;
   }
  TR0=0;						//Clear Timer 0 run bit.
  TL0=0xFC;					//Load the count for a delay of 50msec in TL0 and TH0.
  TH0=0x4B;
  TR0=1;						//Set the Timer 0 in run mode.
  TF0=0;						//Clear Timer 0 overflow flag.
  count--;	 					//Decrement the variable count after every 50msec.
}
void main()
{								  
	if(sw)
	count=5;				//Initialize count to 10 or 5 according to the switch position.
	else
	count=10;
   	mybit=1;				//Set P1.5 pin to logic 1.
  	 IE=0x82;				//Enable Timer 0 interrupt and global interrupt.
   	TMOD=0x01;				//Initialize timer 0 as timer and in mode 1.
   	TL0=0xFC;				//Load the count for 50msec in the TL1 and TH1 registers.
   	TH0=0x4B;
   	TR0=1;				//Set Timer 0 in run mode.
   	while(1)
   	{
   	}						//Do nothing loop. Wait for interrupt.
}
