#include<reg51.h>
char name[]={"Harish G. Narula"};	//String initialization to store the name.
char i=0;								//Variable to store index number of the current character in the string.
void serialISR(void) interrupt 4			//ISR for Serial communication
{
	if(TI)								//If interrupt is because of TI then transmit the next byte by putting it 
	{									// into the SBUF.
	i++;								//Hence increment the index variable i.
	TI=0;								//Clear the TI flag.
	if(i<16)							//If the last character is already transmitted then no more 
	SBUF=name[i];						// transmission else next character into SBUF.
	}
}
void main()
{
	SCON=0x50;							//Initialize serial port in mode 1 and enable reception.
	TL1=0xFD;							//Initialize timer 1 count for a baud rate of 9600.
	IE=0x90;							//Enable serial and global interrupts.
	TMOD=0X20;						//Initialize timer 1 in mode 2 to generate baud rate.
	SBUF=name[i];						//Transmit the first character
	TR1=1;							//Enable timer 1.

	while(1)							//Do nothing loop. Wait for interrupt.
	{
	}
}
