		# include <reg51.h>
			sbit mybit = P1 ^ 5;			// Define mybit as P1.5 pin 
			void delay (void) interrupt 3 			// ISR for timer 1
			{
				mybit = ~ mybit ; 			// Toggle P1.5 pin
				TF1 = 0 ;				// Clear timer 1 overflow flag
			}
			void main ( )
			{
				mybit = 1 ;				// set P1.5 pin to logic 1
				IE = 0x88 ;				// Enable Timer 1 and Global interrupts 
				TMOD = 0x20 ;			// Timer 1 as timer and in Mode 2
				TH1 = 0xD2 ;			// Load the reload count as D2H
				TL1 = 0xD2 ;			// Load the counter register as D2H
				TR1=1;				// Set time 1 in Run mode	
				while (1)
				{					// Do nothing wait for interrupt
				}
			}
