	# include <reg51.h>
		sbit mybit = P1^5;				// Define mybit as P1.5 pin
		char x, y, z, p, q;					//Global variables to store count
		void delay (void)	interrupt 3			//ISR for timer 1.
		{
			mybit = ~ mybit;				// Toggle P1.5 pin
			TR1 = 0;					// Clear Timer 1 run bit
			z = p;						// Swap the counts in
			TL1 = x;					// the variables and load
			p = x;						// the new counts in TL1
			x = z;						// and TH1
			z = q;					
			TH1 = y;
			q = y;
			y = z;
			TR1 = 1;					// set Timer 1 in run mode
			TF1 = 0;					// clear Timer 1 overflow flag.
		}
		void main ( )
		{
		mybit = 1 ;						// Set P1.5 pin to logic 1.
		IE = 0x88 ;						// Enable Timer 1 and global interrupts
		TMOD = 0x10;					// Set timer 1 as timer and in Mode 1
		x = 0xFF;						// Load the counts into the Variables
		y = 0xDB ;			
		p = 0x32 ;
		q = 0xF5 ;
		TL1 = p ;						// Load the count for 3 msec in the 
		TH1 = q ;						// TL1 and TH1 register
		TR1 = 1 ; 						//set timer 1 in run mode
		while (1)		
		{
		;							// Do nothing. Wait for interrupt.
		}
	}
